#include "../includes/recherche.h"
#include "../includes/structures.h"

void	fusionMaillonDevis(ListeDevis R, int tR, ListeDevis S, int tS, ListeDevis *T, int *tT)
{
	ListeDevis	pT;
	int			k;
    
	*T = NULL;
	pT = *T;
	k = 0;
	while (R && S)
	{
		if (strcmp(R->dev.nomE, S->dev.nomE) < 0)
		{
			if (!*T)
			{
				*T = (ListeDevis)malloc(sizeof(MaillonDevis));
				pT = *T;
			}
			else
			{
				pT->suiv = (ListeDevis)malloc(sizeof(MaillonDevis));
				pT = pT->suiv;
			}
			pT->dev = R->dev;
			R = R->suiv;
		}
		else
		{
			if (!*T)
			{
				*T = (ListeDevis)malloc(sizeof(MaillonDevis));
				pT = *T;
			}
			else
			{
				pT->suiv = (ListeDevis)malloc(sizeof(MaillonDevis));
				pT = pT->suiv;
			}
			pT->dev = S->dev;
			S = S->suiv;
		}
		pT->suiv = NULL;
		k++;
	}
	while (R)
	{
		if (!*T)
		{
			*T = (ListeDevis)malloc(sizeof(MaillonDevis));
			pT = *T;
		}
		else
		{
			pT->suiv = (ListeDevis)malloc(sizeof(MaillonDevis));
			pT = pT->suiv;
		}
		pT->dev = R->dev;
		R = R->suiv;
		pT->suiv = NULL;
		k++;
	}
	while (S)
	{
		if (!*T)
		{
			*T = (ListeDevis)malloc(sizeof(MaillonDevis));
			pT = *T;
		}
		else 
		{
			pT->suiv = (ListeDevis)malloc(sizeof(MaillonDevis));
			pT = pT->suiv;
		}
		pT->dev = S->dev;
		S = S->suiv;
		pT->suiv = NULL;
		k++;
	}
	*tT = k;
}

void	triFusionListeDevis(ListeDevis *ldevis, int *tlog)
{
	ListeDevis	p;
	ListeDevis	q;
	int tR;
	int tS;
	int	i;

	tR = *tlog / 2;
	tS = *tlog - tR;
	p = *ldevis;
	if (!p)
	{
		*tlog = 0;
		return;
	}
	if (!(p->suiv))
	{
	*tlog = 1;
		return;
	}
	q = p;
	for (i = 0; i < tR - 1; i++)
	{
		if (!q)
			break;
		q = q->suiv;
	}
	if (!q)
		return;
	ListeDevis temp = q->suiv;
	q->suiv = NULL;
	triFusionListeDevis(ldevis, &tR);
	triFusionListeDevis(&temp, &tS);
	fusionMaillonDevis(*ldevis, tR, temp, tS, ldevis, tlog);
}

/*------------------------affichage-----------------------------------*/

void	afficherListeDevis(ListeDevis ldevis)
{
	while (ldevis)
	{
		printf("%s, ", ldevis->dev.nomE);
		ldevis = ldevis->suiv;
	}
	printf("\n");
}

void	afficherOffre(Offre *offre)
{
	printf("Travaux: %s\n\t", offre->travaux);
	afficherListeDevis(offre->ldevis);
}

/*---------------------------------------------------------------------*/

/*
int	main(void)
{
	Offre offre1 = {"Travaux1", NULL};
	offre1.ldevis = (ListeDevis)malloc(sizeof(MaillonDevis));
	offre1.ldevis->dev = (Devis){"Devis6", "Adresse1", 100, 5};
	offre1.ldevis->suiv = (ListeDevis)malloc(sizeof(MaillonDevis));
	offre1.ldevis->suiv->dev = (Devis){"Devis3", "Adresse3", 80, 3};
	offre1.ldevis->suiv->suiv = NULL;

	Offre offre2 = {"Travaux2", NULL};
	offre2.ldevis = (ListeDevis)malloc(sizeof(MaillonDevis));
	offre2.ldevis->dev = (Devis){"Devis2", "Adresse2", 120, 7};
	offre2.ldevis->suiv = (ListeDevis)malloc(sizeof(MaillonDevis));
	offre2.ldevis->suiv->dev = (Devis){"Devis4", "Adresse4", 90, 4};
	offre2.ldevis->suiv->suiv = NULL;

	printf("Avant le tri : \n");
	afficherOffre(&offre1);
	afficherOffre(&offre2);

	int tlog1 = 0;
	triFusionListeDevis(&offre1.ldevis, &tlog1);

	int tlog2 = 2;
	triFusionListeDevis(&offre2.ldevis, &tlog2);

	printf("\nApres le tri : \n");
	afficherOffre(&offre1);
	printf("Taille logique : %d\n", tlog1);

	afficherOffre(&offre2);
	printf("Taille logique : %d\n", tlog2);

	return (0);
}
*/